/*
	A simple text highlighter for webpages using context menu
	By 	Simon Shareef (simonshareef@gmail.com)
		Male', Republic of Maldives
	http://maldivian.blogs.com/tech/
	This is free software licensed under the GPL

	Change log is @ CHANGES.LOG
*/


var textMarker = {
	/* function to do some initialisation work */
	init : function () {
		
    //* localizing initial description :o)
    
   var textmarkerLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{1c530060-b0ae-11d9-9669-0800200c9a66}.");
   var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
   str.data = document.getElementById("textmarker-strings").getString("textmarker.description");
   textmarkerLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );
    
    
    
    var context = document.getElementById("contentAreaContextMenu");
    		textMarker.optionsMenu = document.getElementById("context-textMarkerOptionsMenu");
    		textMarker.copyHighlights = document.getElementById("context-textMarkerCopyHighlights");
    		textMarker.copyThisHighlight = document.getElementById("context-textMarkerCopyThisHighlight");
    		textMarker.clearHighlights = document.getElementById("context-textMarkerClearHighlights");
    		textMarker.clearThisHighlight = document.getElementById("context-textMarkerClearThisHighlight");
    		textMarker.highlightThis = document.getElementById("context-textMarkerHighlight");
    		context.addEventListener("popupshowing",textMarker.popup,false);
	},


	/* function to display the context menu depending on various factors */
	popup : function() {
		
		textMarker.highlightThis.hidden = !gContextMenu.isTextSelected;

		if (gContextMenu.target.ownerDocument) {
			textMarker.currentDocument = gContextMenu.target.ownerDocument;			
			var targetClass = gContextMenu.target.getAttribute("name");
			
			textMarker.optionsMenu.hidden = !(textMarker.currentDocument.slindex > 0); 
			textMarker.clearHighlights.hidden = !(textMarker.currentDocument.slindex > 0);
			textMarker.copyHighlights.hidden = !(textMarker.currentDocument.slindex > 0);
			
			textMarker.currentDocument.hlCurrentBlock = "";
			textMarker.clearThisHighlight.hidden = true;
			textMarker.copyThisHighlight.hidden = true;
			if (targetClass != null) {
				if (targetClass.substr(0,10) == "textmarker") {
					textMarker.clearThisHighlight.hidden = false;
					textMarker.copyThisHighlight.hidden = false;
					textMarker.currentDocument.hlCurrentBlock = targetClass;
				}
			}
		}
	},


	/* function to get the selected range and start of the highlighting process is here */
	/* This function code has been replaced by Hemiola SUN's code from his work of TextMarker Plus! 0.3*/
	highlight: function(evt) { 
		var focusedWindow = document.commandDispatcher.focusedWindow;
		if (focusedWindow == window)
			focusedWindow = _content; 
		var selection = focusedWindow.getSelection();
		if (textMarker.currentDocument != focusedWindow.document) 
			textMarker.currentDocument = focusedWindow.document;
			
		textMarker.currentDocument.hlcolor = textMarker.getColor(1); 
		
		if (!textMarker.currentDocument.hlcount) {
			textMarker.currentDocument.slindex = 0;
			textMarker.currentDocument.hlcount = 0;
			textMarker.currentDocument.hlCycleIndex = 0;
		}
			if (evt) {
				var unUsed = !(evt.charCode == 109 || evt.charCode == 77 || evt.charCode == 98 || evt.charCode == 66 || evt.charCode == 110 || evt.charCode == 78);
				if (unUsed)
					return;
				try {
					var gPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					if (!gPref.getBoolPref("textMarker.useshortcuts")) {
						return;
					}
				} catch(e) {
					return;
				}

				if (evt.charCode == 109 || evt.charCode == 77) 
					textMarker.currentDocument.hlcolor = textMarker.getColor(1);
				if (evt.charCode == 98 || evt.charCode == 66) 
					textMarker.currentDocument.hlcolor = textMarker.getColor(2);
				if (evt.charCode == 110 || evt.charCode == 78)
					textMarker.currentDocument.hlcolor = textMarker.getColor(3);
			}
		var range = focusedWindow.document.createRange();
		var startNode;
		var endNode;
		var startOffset;
		var endOffset;
	
		try {
			range.setStart(selection.anchorNode, selection.anchorOffset);
			range.setEnd(selection.focusNode, selection.focusOffset);
			startNode = selection.anchorNode;
			endNode = selection.focusNode;
			startOffset = selection.anchorOffset;
			endOffset = selection.focusOffset;
		} catch(ex) {
			range.setStart(selection.focusNode, selection.focusOffset);
			range.setEnd(selection.anchorNode, selection.anchorOffset);
			startNode = selection.focusNode;
			endNode = selection.anchorNode;
			startOffset = selection.focusOffset;
			endOffset = selection.anchorOffset;
		}
		range.detach();


	  // increment highlights count
      textMarker.currentDocument.slindex++;

      var matchtext;
      if ( startNode != endNode ) { // selection across many nodes
        matchtext = startNode.splitText(startOffset);
        startNode = matchtext.splitText(matchtext.data.length);
        textMarker.markNode(matchtext);

        // code borrowed from Line Marker of Shimoda Hiroshi, and modified by Hemiola SUN
        var node = startNode;
		traceTree:
		do {
		if (node.hasChildNodes()) {
			node = node.firstChild;
		} else {
			while (!node.nextSibling) {
				node = node.parentNode;
				if (!node) 
					break traceTree;
			}
            node = node.nextSibling;
		}
			if (node == endNode)
				break traceTree;
			if (node.nodeType == Node.TEXT_NODE && !textMarker.is_all_ws(node) ) {
				matchtext = node;
				node = matchtext.splitText(node.data.length);
				textMarker.markNode(matchtext);
			}
		}
        while (node != endNode);

        matchtext = endNode;
        endNode = matchtext.splitText(endOffset);
        textMarker.markNode(matchtext);
      }
      else { // selection in one node
        matchtext = startNode.splitText(startOffset);
        startNode = matchtext.splitText(endOffset-startOffset);
        textMarker.markNode(matchtext);
      }
	  selection.collapseToStart();

	},

	markNode: function(matchtext) {
		var clone = matchtext.cloneNode(true);
		var span =	textMarker.createSpan(clone,matchtext.parentNode);
		matchtext.parentNode.replaceChild(span,matchtext);
	},

	/* function to create a span to hold highlight*/ 
	createSpan : function (node,pNode) { // node is a TEXT node
		nam = pNode.getAttribute("name");
		if (nam != null)
			if (nam.substr(0,10) == "textmarker")
				return node;
		var span = document.createElementNS("http://www.w3.org/1999/xhtml", "span");
		var id_stuff = "textmarked_" + textMarker.currentDocument.hlcount++;
		var name_stuff = "textmarker_" + textMarker.currentDocument.slindex;
		span.setAttribute("id", id_stuff);
		span.setAttribute("name", name_stuff);
		span.style.backgroundColor = textMarker.currentDocument.hlcolor; // "rgb(255,255,0)";
		span.appendChild(node);
		return span;
	},

	/* function to clear highlighting 
	   Code adapted from Ben Basson's Context Highlighter */
	clearHL : function() { 
		if (!textMarker.currentDocument)
			return;
		while (textMarker.currentDocument.hlcount > 0) {
			var id_stuff = "textmarked_" + --textMarker.currentDocument.hlcount;
			var oldSpan = textMarker.currentDocument.getElementById(id_stuff);
			if (oldSpan) {
				var parent = oldSpan.parentNode;
     			parent.replaceChild(oldSpan.childNodes[0], oldSpan);
     			parent.normalize();
			}
		}
		textMarker.currentDocument.hlcount = 0;
		textMarker.currentDocument.slindex= 0;
	},

	/* function to copy all highlighted text */
	copyHL : function() {
		if (!textMarker.currentDocument)
			return;
		var textToCopy = "";
		var count = textMarker.currentDocument.hlcount;
		
		for (var i = 0; i < count ; i++) {
			var id_stuff = "textmarked_" + i;
			var nod = textMarker.currentDocument.getElementById(id_stuff);
			if (i == 0)
				hlFlag = nod.getAttribute("name");
			if (nod) {
				if (hlFlag != nod.getAttribute("name")) { // are we in the same highlight
					textToCopy += "\r\n" + nod.firstChild.data;
					hlFlag = nod.getAttribute("name");
				} else 
					textToCopy += nod.firstChild.data;
			}
		}
		textMarker.copyToClipboard(textToCopy);//copy to clipboard

	}, 

	/* function to clear highlighting from a particular block */
	clearThisHL : function() {
		if (!textMarker.currentDocument)
			return;
		currentBlock = textMarker.currentDocument.hlCurrentBlock;
		var nodesToClear = textMarker.currentDocument.getElementsByName(currentBlock);
		textMarker.clearNodes(nodesToClear);
	},

	clearNodes : function (nodesToClear) {
		if (!textMarker.currentDocument)
			return;
		for (var i = nodesToClear.length-1; i >= 0; i--) {
			var oldSpan = nodesToClear.item(i);
			var parent = oldSpan.parentNode;
     			parent.replaceChild(oldSpan.childNodes[0], oldSpan);
     			parent.normalize();
		}
	},

	/* function to copy only the Highlighted text under the mouse */
	copyThisHL : function () {
		if (!textMarker.currentDocument)
			return;
		currentBlock = textMarker.currentDocument.hlCurrentBlock;
		var nodesToCopy = textMarker.currentDocument.getElementsByName(currentBlock);
		var textToCopy = "";
		for (var i = 0; i < nodesToCopy.length; i++) {
			var nod = nodesToCopy.item(i);
			textToCopy += nod.firstChild.data;
		}
		textMarker.copyToClipboard(textToCopy);//copy to clipboard
	},

	copyToClipboard : function (toCopy) {
        var clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
						.getService(Components.interfaces.nsIClipboardHelper);
		toCopy += "\r\n(Source URL: " + textMarker.currentDocument.URL + ")";
        clipboard.copyString(toCopy);
	},
	
	/* function to dump messages on the Javascript console */
	debug : function (aMessage) {
  		var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  		consoleService.logStringMessage("TextMarker: " + aMessage);
	},

	/* helper function to check for new lines, carriage returns and tabs */
	is_all_ws :	function( nod ) {
  		// Use ECMA-262 Edition 3 String and RegExp features
  		return !(/[^\t\n\r ]/.test(nod.data));
	},
	

	getColor : function (id) {
		try {
			var gPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			if ((gPref.getBoolPref("textMarker.cyclecolors") == true) && (id == 1)) {
				textMarker.currentDocument.hlCycleIndex++;
				if (textMarker.currentDocument.hlCycleIndex == 4)
					textMarker.currentDocument.hlCycleIndex = 1;
				return gPref.getCharPref("textMarker.color" + textMarker.currentDocument.hlCycleIndex);
			} else
				return gPref.getCharPref("textMarker.color" + id);
		} catch(e) {
			return "#FFFF00"; // yellow
		}
			
	},

	

}
window.addEventListener("load", textMarker.init,false);
window.addEventListener("keypress", textMarker.highlight,false);
